#include <arch/romcc_io.h>
#include "it8716f.h"

static inline void pnp_enter_ext_func_mode(device_t dev) 
{
	unsigned port = dev>>8;
        outb(0x87, port);
        outb(0x01, port);
        outb(0x55, port);
	if(port == 0x4e) {
        	outb(0xaa, port);
	} else {
        	outb(0x55, port);
	}
}
static void pnp_exit_ext_func_mode(device_t dev) 
{
	pnp_write_config(dev, 0x02, 0x02);
}
static void it8716f_enable_serial(device_t dev, unsigned iobase)
{
	pnp_enter_ext_func_mode(dev);
	pnp_set_logical_device(dev);
	pnp_set_enable(dev, 0);
	pnp_set_iobase(dev, PNP_IDX_IO0, iobase);
	pnp_set_enable(dev, 1);
	pnp_exit_ext_func_mode(dev);
}
